/*
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// addin.cpp : Implementation of Caddin
#include "stdafx.h"
#include "OutlookAddin.h"
#include "addin.h"

/////////////////////////////////////////////////////////////////////////////
// Caddin
#define APP_NAME        L"Funambol Outlook Plug-in"
#define AMP_SYNC4J      TEXT("&Funambol")      
STDMETHODIMP Caddin::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_Iaddin
	};
	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

STDMETHODIMP Caddin::OnConnection(IDispatch * Application, ext_ConnectMode ConnectMode, IDispatch * AddInInst, SAFEARRAY * * custom) {
     
    CComVariant vEmpty(DISP_E_PARAMNOTFOUND, VT_ERROR);

    _ApplicationPtr spApp(Application);    
    _ExplorerPtr    spExplorer;
    CComPtr <Office::_CommandBars> spCmdBars;
    VARIANT variant;
	variant.vt = VT_BSTR;
   
    CommandBarControlPtr commandBarControlPtr;
    spApp->ActiveExplorer(&spExplorer);
   
	HRESULT hRes = spExplorer->get_CommandBars(&spCmdBars); 
    if(FAILED(hRes)) {        
        return hRes;
    }
   
    CommandBarPtr spCmdBar;
	   	
	variant.bstrVal = SysAllocString(APP_NAME);
	
    hRes = spCmdBars->get_Item(variant,&spCmdBar);
	
    VariantClear(&variant);
   
    if (SUCCEEDED(hRes)) {
        hRes = spCmdBar->Delete();
    } 
    
    //
    // remove the sync4j bar
    //

    CommandBarPopupPtr pMenuItem; 
    CComPtr < Office::CommandBarControls> spCmdCtrls;
    CComPtr < Office::CommandBarControl> spCmdCtrl;
    
    // get CommandBar that is Outlook's main menu
    HRESULT hr = spCmdBars->get_ActiveMenuBar(&spCmdBar); 

    if (FAILED(hr)) {
        return hr;
    }
        
    spCmdCtrls = spCmdBar->GetControls(); 
    ATLASSERT(spCmdCtrls);
    
    hr = spCmdCtrls->get_Item(CComVariant(AMP_SYNC4J), &spCmdCtrl);   

    
    if (SUCCEEDED(hr)) {
        CommandBarPopupPtr pMenuItem; 
        pMenuItem = spCmdBars->ActiveMenuBar->Controls->GetItem(AMP_SYNC4J);
        pMenuItem->Delete(vtMissing);

    }   

    DllUnregisterServer();

    return S_OK;
}